"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreflightCheckStore = void 0;
class PreflightCheckStore {
    constructor() {
        this.preflightChecks = [];
    }
    async add(check) {
        if ((await this.get(check.checkId)) === null) {
            this.preflightChecks.push(check);
        }
    }
    async get(checkId) {
        const entry = this.preflightChecks.find((c) => c.checkId === checkId);
        return Promise.resolve(entry !== undefined ? entry : null);
    }
    async getAll() {
        return [...this.preflightChecks];
    }
}
exports.PreflightCheckStore = PreflightCheckStore;
//# sourceMappingURL=preflight-check-store.js.map