var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BrokerServerPostResponseHandler_instances, _BrokerServerPostResponseHandler_buffer, _BrokerServerPostResponseHandler_logContext, _BrokerServerPostResponseHandler_config, _BrokerServerPostResponseHandler_brokerToken, _BrokerServerPostResponseHandler_streamingId, _BrokerServerPostResponseHandler_serverId, _BrokerServerPostResponseHandler_requestId, _BrokerServerPostResponseHandler_initBuffer, _BrokerServerPostResponseHandler_sendIoData, _BrokerServerPostResponseHandler_handleRequestError;
let request = require('request');
const logger = require('./log');
const stream = require('stream');
const { replaceUrlPartialChunk } = require('./replace-vars');
request = request.defaults({
    timeout: 60000,
    agentOptions: {
        keepAlive: true,
        keepAliveMsecs: 60000,
        maxTotalSockets: 1000,
    },
});
const BROKER_CONTENT_TYPE = 'application/vnd.broker.stream+octet-stream';
class BrokerServerPostResponseHandler {
    constructor(logContext, config, brokerToken, streamingId, serverId, requestId) {
        _BrokerServerPostResponseHandler_instances.add(this);
        _BrokerServerPostResponseHandler_buffer.set(this, void 0);
        _BrokerServerPostResponseHandler_logContext.set(this, void 0);
        _BrokerServerPostResponseHandler_config.set(this, void 0);
        _BrokerServerPostResponseHandler_brokerToken.set(this, void 0);
        _BrokerServerPostResponseHandler_streamingId.set(this, void 0);
        _BrokerServerPostResponseHandler_serverId.set(this, void 0);
        _BrokerServerPostResponseHandler_requestId.set(this, void 0);
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_logContext, logContext, "f");
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_config, config, "f");
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_brokerToken, brokerToken, "f");
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_streamingId, streamingId, "f");
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_serverId, serverId, "f");
        __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_requestId, requestId, "f");
    }
    forwardRequest(rqst) {
        let prevPartialChunk;
        let isResponseJson;
        rqst
            .on('error', __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_handleRequestError).call(this))
            .on('response', (response) => {
            const status = (response === null || response === void 0 ? void 0 : response.statusCode) || 500;
            logger.info({
                ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"),
                responseStatus: status,
                responseHeaders: response.headers,
            }, 'response received, setting up stream to Broker Server');
            isResponseJson = isJson(response.headers);
            const ioData = JSON.stringify({
                status,
                headers: response.headers,
            });
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_initBuffer).call(this);
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_sendIoData).call(this, ioData);
            logger.info(__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), 'successfully sent status & headers to Broker Server');
        })
            .on('data', (chunk) => {
            const httpBody = __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_config, "f") && __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_config, "f").LOG_ENABLE_BODY === 'true'
                ? { body: chunk.toString() }.body
                : null;
            logger.debug({ ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), chunkLength: chunk.length, httpBody }, 'writing data to buffer');
            if (__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_config, "f").RES_BODY_URL_SUB && isResponseJson) {
                const { newChunk, partial } = replaceUrlPartialChunk(Buffer.from(chunk).toString(), prevPartialChunk, __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_config, "f"));
                prevPartialChunk = partial;
                chunk = newChunk;
            }
            if (!__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").write(chunk)) {
                logger.trace(__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), 'pausing request stream');
                rqst.pause();
                __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").once('drain', () => {
                    logger.trace(__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), 'resuming request stream');
                    rqst.resume();
                });
            }
        })
            .on('end', () => {
            logger.info(__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), 'writing end to buffer');
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").end();
        });
    }
    sendData(responseData) {
        const body = responseData.body;
        delete responseData.body;
        logger.debug({ ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), responseData, body }, 'posting internal response back to Broker Server as it is expecting streaming response');
        __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_initBuffer).call(this);
        __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_sendIoData).call(this, JSON.stringify(responseData));
        __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").write(JSON.stringify(body));
        __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").end();
    }
}
_BrokerServerPostResponseHandler_buffer = new WeakMap(), _BrokerServerPostResponseHandler_logContext = new WeakMap(), _BrokerServerPostResponseHandler_config = new WeakMap(), _BrokerServerPostResponseHandler_brokerToken = new WeakMap(), _BrokerServerPostResponseHandler_streamingId = new WeakMap(), _BrokerServerPostResponseHandler_serverId = new WeakMap(), _BrokerServerPostResponseHandler_requestId = new WeakMap(), _BrokerServerPostResponseHandler_instances = new WeakSet(), _BrokerServerPostResponseHandler_initBuffer = function _BrokerServerPostResponseHandler_initBuffer() {
    __classPrivateFieldSet(this, _BrokerServerPostResponseHandler_buffer, new stream.PassThrough({ highWaterMark: 1048576 }), "f");
    const url = new URL(`${__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_config, "f").brokerServerUrl}/response-data/${__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_brokerToken, "f")}/${__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_streamingId, "f")}`);
    url.searchParams.append('server_id', __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_serverId, "f"));
    const brokerServerPostRequestUrl = url.toString();
    const brokerServerPostRequest = request({
        url: brokerServerPostRequestUrl,
        method: 'post',
        headers: {
            'Snyk-Request-Id': __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_requestId, "f"),
            'Content-Type': BROKER_CONTENT_TYPE,
            Connection: 'Keep-Alive',
            'Keep-Alive': 'timeout=60, max=1000',
        },
    });
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").on('error', (e) => logger.error({
        ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"),
        error: e,
        stackTrace: new Error('stacktrace generator').stack,
    }, 'received error sending data to broker server post request buffer'));
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").pipe(brokerServerPostRequest
        .on('error', (e) => {
        logger.error({
            ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"),
            error: e,
            stackTrace: new Error('stacktrace generator').stack,
        }, 'received error sending data via POST to Broker Server');
        __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").destroy(e);
    })
        .on('response', (r) => {
        var _a;
        if (r.statusCode !== 200) {
            logger.error({
                ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"),
                statusCode: r.statusCode,
                statusMessage: r.statusMessage,
                headers: r.headers,
                body: (_a = r.body) === null || _a === void 0 ? void 0 : _a.toString(),
                stackTrace: new Error('stacktrace generator').stack,
            }, 'Received unexpected HTTP response POSTing data to Broker Server');
        }
    }));
    logger.debug(__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), 'Pipe set up');
}, _BrokerServerPostResponseHandler_sendIoData = function _BrokerServerPostResponseHandler_sendIoData(ioData) {
    const ioDataLength = ioData.length;
    logger.debug({ ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"), ioDataLength }, `sending ioData (Status & Headers) to Broker Server`);
    // Would be nice if there were a Unit32Array or a writeUint32 method, but noooooo...
    const ioDataLengthBinary = new Uint8Array(4);
    ioDataLengthBinary[0] = ioDataLength & 0xff;
    ioDataLengthBinary[1] = (ioDataLength >> 8) & 0xff;
    ioDataLengthBinary[2] = (ioDataLength >> 16) & 0xff;
    ioDataLengthBinary[3] = (ioDataLength >> 24) & 0xff;
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").cork();
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").write(ioDataLengthBinary);
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").write(ioData);
    __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").uncork();
}, _BrokerServerPostResponseHandler_handleRequestError = function _BrokerServerPostResponseHandler_handleRequestError() {
    // For reasons unknown, doing foo.on(this.#func)
    // doesn't work - you need return a function from here
    return (error) => {
        logger.error({
            ...__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_logContext, "f"),
            error,
            stackTrace: new Error('stacktrace generator').stack,
        }, 'received error from request while piping to Broker Server');
        // If we already have a buffer object, then we've already started sending data back to the original requestor,
        // so we have to destroy the stream and let that flow through the system
        // If we *don't* have a buffer object, then there was a major failure with the request (e.g., host not found), so
        // we will forward that directly to the Broker Server
        if (__classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f")) {
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").destroy(error);
        }
        else {
            const body = JSON.stringify({ error: error });
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_initBuffer).call(this);
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_instances, "m", _BrokerServerPostResponseHandler_sendIoData).call(this, JSON.stringify({
                status: 500,
                headers: {
                    'Content-Length': `${body.length}`,
                    'Content-Type': 'application/json',
                },
            }));
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").write(body);
            __classPrivateFieldGet(this, _BrokerServerPostResponseHandler_buffer, "f").end();
        }
    };
};
function isJson(responseHeaders) {
    var _a;
    return ((_a = responseHeaders['content-type']) === null || _a === void 0 ? void 0 : _a.includes('json')) || false;
}
module.exports = {
    BrokerServerPostResponseHandler,
};
//# sourceMappingURL=stream-posts.js.map